MainProgram:
   while true
      GoSub SetUp
      while true
          if AllowDisconnect && Left(tcps_Status(),19) == "Client Disconnected" then break
      wend
   wend   
End
//==================================================================================
SetUp:
   lclPort = 41000 \ LineWidth 4 \ clearscr
   xystring 50,100,"This is the Robot side (server) and it is ready to "
   xystring 50,120,"obey commands from a connected Controller (client)."
   xystring 50,140,"The robot's IP:  "
   xyText   -1,-1, tcp_LocalIP(),"",0,fs_Bold|fs_Underlined
   xystring 50,160,"The robot's Port:"
   xyText   -1,-1, lclPort,"",0,fs_Bold|fs_Underlined
   AllowDisconnect = false
   n = tcps_Serve(lclPort) \ ontcps tcpHandler
Return
//==================================================================================
tcpHandler:
    AllowDisconnect = true
    rBuff = tcps_Read()
    Code = getstrbyte(rBuff,1) \ Amount = getstrbyte(rBuff,2)
    esBuff = char(0)+char(0)
    if Code == 1 //no action
        //nada
    elseif Code == 3 //init
        clearscr \ rlocate 400,300 \ rinvisible green,red
    elseif Code == 6 //forward 
        rForward Amount 
    elseif Code == 7 //backward 
        rForward -Amount 
    elseif Code == 12 //turn right
        rTurn Amount 
    elseif Code == 13 //turn left
        rTurn -Amount 
    elseif Code == 36 //speed
        rSpeed Amount 
    elseif Code == 129 //pen
        rPen Amount 
    elseif Code == 48 //look right
        n = rLook(Amount) \ esBuff = toByte(n>>8)+tobyte(n) 
    elseif Code == 49 //look left
        n = rLook(-Amount) \ esBuff = toByte(n>>8)+tobyte(n) 
    elseif Code == 96 //beacon
        n = rBeacon(Amount) \ esBuff = toByte(n>>8)+tobyte(n) 
    elseif Code == 192 //range right
        n = rRange(Amount) \ esBuff = toByte(n>>8)+tobyte(n) 
    elseif Code == 193 //range left
        n = rRange(-Amount) \ esBuff = toByte(n>>8)+tobyte(n) 
    elseif Code == 255 //snap picture
        gosub SendSnap
    endif
    sBuff = ""
    BuffPrintB sBuff,toByte(rBumper()),toByte(rFeel()),toByte(rSense())
    X = rGpsX() \ Y = rGpsY()
    sBuff = sBuff+toByte(X>>8)+tobyte(X)+toByte(Y>>8)+toByte(Y)
    n= rCompass() \ sBuff = sBuff+toByte(n>>8)+tobyte(n) 
    if Code != 255 then n = tcps_Send(sBuff+esBuff)
    onTCPS tcpHandler
return
//==================================================================================
SendSnap:
    buff_size = 6144
    n = tcps_read() //clear buff
    WriteScr "temp"
    hi = Fileopen("temp.bmp",fo_Read)
    while true
       s = FileRead(hi,buff_size)
       n=tcps_send(s)
       while !tcps_buffcount()
       wend
       ss = tcps_read()
       if Length(s) < buff_size then break
    wend
    x = FileClose(hi)
    x = tcps_Send("Finished Sending")
Return
//==================================================================================
