MainProgram:
   while true
      GoSub SetUp
      GoSub Connect
      if left(Status,9) == "Connected" then GoSub MonitorInputs
   wend
End
//==================================================================================
MonitorInputs:
   while true
      xystring 380,40,tcpc_Status(),spaces(40)
      if tcpc_Status() == "Disconnected" then break
      if !vType(FirstTime) then sBuff = char(3)+char(0) \ gosub sendData \ FirstTime = false
      if keydown(37) then Amount = -1 \ Gosub RobTurn
      if keydown(39) then Amount = 1 \ Gosub RobTurn
      if keydown(38) && !(Bumper & 4) then Amount = 1 \ Gosub RobForward
      if keydown(40) && !(Bumper & 1) then Amount = -1 \ GoSub RobForward
      if keyDown(Ascii("P")) then gosub RobPen 
      if keydown(Ascii("Q")) then gosub ReceiveFile \ waitnokeyE Ascii("Q")
   wend
Return
//==================================================================================
SetUp:
   rmtPort = 41000 \ rmtIP = tcp_LocalIP()
   if !vType(FT)
      Addedit "rmtPort",370,2,60,0,rmtPort \ IntegerEdit "rmtPort"
      Addedit "rmtIP",515,2,100,0,rmtIP \ FT = false
   endif
   clearscr
   xyText 280,2,"Robot's Port:","Times NEw Roman",0,fs_Bold
   xyText 435,2,"Robot's IP:","Times NEw Roman",0,fs_Bold
   xystring 50,100,"1-Make sure the Robot side (server) is up and running."
   xystring 50,120,"2-Then enter the IP address and Port the robot is serving."
   xystring 50,140,"3-Then click the button below to connect to the robot and"
   xystring 50,160,"  start the demo."
   xystring 50,190,"Press Up/Dn arrows to go forward and backwards respectively."
   xystring 50,210,"Press Lft/Rt arrows to turn left and right respectively."
   xystring 50,230,"Press 'p' to toggle the pen up/down."
   xystring 50,250,"Press 'q' to obtain a snap shot of the robots screen."
   AddButton "Connect",300,290,100
   while LastButton() == ""
   wend
Return
//==================================================================================
Connect:
   rectanglewh 20,80,800,600,white,white
   removebutton "Connect"
   n = tcpc_connect(GetEDit("rmtIP"),ToNumber(GetEDit("rmtPort")))
   t = timer()
   while timer()-t < 10000
      Status = tcpc_Status()
      if left(Status,9) == "Connected" then break
      if left(Status,5) == "Error" then break
   wend
   Bumper = 0 \ Feel = 0 \ Sense = 0 \ Pen = false \ XPos=0 \ YPos=0 \ Heading=0
   rectanglewh 48,78,704,504
Return
//==================================================================================
RobForward:
   Code = 6
   if Amount < 0 then Code = 7
   sBuff = char(Code)+char(Abs(Amount)) \ gosub sendData
return
//==================================================================================
RobTurn:
   Code = 12
   if Amount < 0 then Code = 13
   sBuff = char(Code)+char(Abs(Amount)) \ gosub sendData
return
//==================================================================================
RobPen:
    WaitNoKeyE Ascii("P") \ Pen = !Pen 
    sBuff = char(129)+char(Pen) \gosub sendData
Return
//==================================================================================
sendData:
    n = tcpc_Send(sBuff)
    while tcpc_BuffCount() < 11
    wend
    n = tcpc_Read()
    Bumper = getstrbyte(n,1) \ Feel = getstrbyte(n,2) \ Sense = getstrbyte(n,3)
    XPos =(getstrbyte(n,4)<<8)+getstrbyte(n,5)
    YPos =(getstrbyte(n,6)<<8)+getstrbyte(n,7)
    Heading = (getstrbyte(n,8)<<8) + getstrbyte(n,9)
    xystring 1,1,"Bumper= ",Bumper,"  Feel=",Feel,"  Sense=",Sense,spaces(2)
    xystring 1,20,"Heading=",Heading,"   X=",XPos,"   Y=",YPos,spaces(10)
Return
//==================================================================================
ReceiveFile:
   x = tcpc_read() //clear buff
   ho = FileCreate("ScreenShot.bmp")
   n = tcpc_Send(char(255)+char(0))
   while true
      while !tcpc_buffcount()
      wend
      s = tcpc_read()
      if s == "Finished Sending" then break
      x = FileWrite(ho,s)
      x = tcpc_Send("OK")
   wend
   x = FileClose(ho)
   rectanglewh 48,78,704,504
   onerror errHandler
   FitBmp "ScreenShot",50,80,700,500 
Return
//==================================================================================
errHandler:
   x = tcpc_read()
return
//==================================================================================
